package org.eso.oca.data;


/**
 * Class DidParameter
 *
 * Business object representing a row on did_parameters table from dic database
 * 
 * @version $Revision: 1.3 $
 * @author pnunes, Apr 22, 2005
 */

public class DidParameter
 
{
    private Long code;
    private boolean code_is_modified = false;
    private boolean code_is_initialized = false;
    
    private String parameter;
    private boolean parameter_is_modified = false;
    private boolean parameter_is_initialized = false;
    
    private String zclass;
    private boolean zclass_is_modified = false;
    private boolean zclass_is_initialized = false;
    
    private String context;
    private boolean context_is_modified = false;
    private boolean context_is_initialized = false;
    
    private String type;
    private boolean type_is_modified = false;
    private boolean type_is_initialized = false;
    
    private String format;
    private boolean format_is_modified = false;
    private boolean format_is_initialized = false;
    
    private String unit;
    private boolean unit_is_modified = false;
    private boolean unit_is_initialized = false;
    
    private String comment;
    private boolean comment_is_modified = false;
    private boolean comment_is_initialized = false;
    
    private String description;
    private boolean description_is_modified = false;
    private boolean description_is_initialized = false;
    
    private String range;
    private boolean range_is_modified = false;
    private boolean range_is_initialized = false;
    
    private String defaultValue;
    private boolean defaultValue_is_modified = false;
    private boolean defaultValue_is_initialized = false;
    
    private Integer mandatory;
    private boolean mandatory_is_modified = false;
    private boolean mandatory_is_initialized = false;
    
    private Integer zprotected;
    private boolean zprotected_is_modified = false;
    private boolean zprotected_is_initialized = false;
    
    private boolean _isNew = true;
    
    /**
     * Do not use this constructor directly, please use the factory method
     * available in the associated manager.
     */
    DidParameter()
    {
    }
    
    /**
     * Getter method for code.
     * <br>
     * Meta Data Information (in progress):
     * <ul>
     * <li>full name: did_parameters.code
     * <li>column size: 10
     * <li>jdbc type returned by the driver: Types.NUMERIC
     * </ul>
     *
     * @return the value of code
     */
    public Long getCode()
    {
        return code; 
    }

    /**
     * Setter method for code.
     * <br>
     * The new value is set only if compareTo() says it is different,
     * or if one of either the new value or the current value is null.
     * In case the new value is different, it is set and the field is marked as 'modified'.
     *
     * @param newVal the new value to be assigned to code
     */
    public void setCode(Long newVal) {
        if ((newVal != null && this.code != null && (newVal.compareTo(this.code) == 0)) || 
            (newVal == null && this.code == null && code_is_initialized)) {
            return; 
        } 
        this.code = newVal; 
        code_is_modified = true; 
        code_is_initialized = true; 
    }

    /**
     * Setter method for code.
     * <br>
     * Convenient for those who do not want to deal with Objects for primary types.
     *
     * @param newVal the new value to be assigned to code
     */
    public void setCode(long newVal) {
        setCode(new Long(newVal));
    }

    /**
     * Determines if the code has been modified.
     *
     * @return true if the field has been modified, false if the field has not been modified
     */
    public boolean isCodeModified() {
        return code_is_modified; 
    }

    /**
     * Determines if the code has been initialized.
     * <br>
     * It is useful to determine if a field is null on purpose or just because it has not been initialized.
     *
     * @return true if the field has been initialized, false otherwise
     */
    public boolean isCodeInitialized() {
        return code_is_initialized; 
    }

    /**
     * Getter method for parameter.
     * <br>
     * Meta Data Information (in progress):
     * <ul>
     * <li>full name: did_parameters.parameter
     * <li>column size: 100
     * <li>jdbc type returned by the driver: Types.VARCHAR
     * </ul>
     *
     * @return the value of parameter
     */
    public String getParameter()
    {
        return parameter; 
    }

    /**
     * Setter method for parameter.
     * <br>
     * The new value is set only if compareTo() says it is different,
     * or if one of either the new value or the current value is null.
     * In case the new value is different, it is set and the field is marked as 'modified'.
     *
     * @param newVal the new value to be assigned to parameter
     */
    public void setParameter(String newVal) {
        if ((newVal != null && this.parameter != null && (newVal.compareTo(this.parameter) == 0)) || 
            (newVal == null && this.parameter == null && parameter_is_initialized)) {
            return; 
        } 
        this.parameter = newVal; 
        parameter_is_modified = true; 
        parameter_is_initialized = true; 
    }

    /**
     * Determines if the parameter has been modified.
     *
     * @return true if the field has been modified, false if the field has not been modified
     */
    public boolean isParameterModified() {
        return parameter_is_modified; 
    }

    /**
     * Determines if the parameter has been initialized.
     * <br>
     * It is useful to determine if a field is null on purpose or just because it has not been initialized.
     *
     * @return true if the field has been initialized, false otherwise
     */
    public boolean isParameterInitialized() {
        return parameter_is_initialized; 
    }

    /**
     * Getter method for zclass.
     * <br>
     * Meta Data Information (in progress):
     * <ul>
     * <li>full name: did_parameters.zclass
     * <li>column size: 100
     * <li>jdbc type returned by the driver: Types.VARCHAR
     * </ul>
     *
     * @return the value of zclass
     */
    public String getZclass()
    {
        return zclass; 
    }

    /**
     * Setter method for zclass.
     * <br>
     * The new value is set only if compareTo() says it is different,
     * or if one of either the new value or the current value is null.
     * In case the new value is different, it is set and the field is marked as 'modified'.
     *
     * @param newVal the new value to be assigned to zclass
     */
    public void setZclass(String newVal) {
        if ((newVal != null && this.zclass != null && (newVal.compareTo(this.zclass) == 0)) || 
            (newVal == null && this.zclass == null && zclass_is_initialized)) {
            return; 
        } 
        this.zclass = newVal; 
        zclass_is_modified = true; 
        zclass_is_initialized = true; 
    }

    /**
     * Determines if the zclass has been modified.
     *
     * @return true if the field has been modified, false if the field has not been modified
     */
    public boolean isZclassModified() {
        return zclass_is_modified; 
    }

    /**
     * Determines if the zclass has been initialized.
     * <br>
     * It is useful to determine if a field is null on purpose or just because it has not been initialized.
     *
     * @return true if the field has been initialized, false otherwise
     */
    public boolean isZclassInitialized() {
        return zclass_is_initialized; 
    }

    /**
     * Getter method for context.
     * <br>
     * Meta Data Information (in progress):
     * <ul>
     * <li>full name: did_parameters.context
     * <li>column size: 32
     * <li>jdbc type returned by the driver: Types.VARCHAR
     * </ul>
     *
     * @return the value of context
     */
    public String getContext()
    {
        return context; 
    }

    /**
     * Setter method for context.
     * <br>
     * The new value is set only if compareTo() says it is different,
     * or if one of either the new value or the current value is null.
     * In case the new value is different, it is set and the field is marked as 'modified'.
     *
     * @param newVal the new value to be assigned to context
     */
    public void setContext(String newVal) {
        if ((newVal != null && this.context != null && (newVal.compareTo(this.context) == 0)) || 
            (newVal == null && this.context == null && context_is_initialized)) {
            return; 
        } 
        this.context = newVal; 
        context_is_modified = true; 
        context_is_initialized = true; 
    }

    /**
     * Determines if the context has been modified.
     *
     * @return true if the field has been modified, false if the field has not been modified
     */
    public boolean isContextModified() {
        return context_is_modified; 
    }

    /**
     * Determines if the context has been initialized.
     * <br>
     * It is useful to determine if a field is null on purpose or just because it has not been initialized.
     *
     * @return true if the field has been initialized, false otherwise
     */
    public boolean isContextInitialized() {
        return context_is_initialized; 
    }

    /**
     * Getter method for type.
     * <br>
     * Meta Data Information (in progress):
     * <ul>
     * <li>full name: did_parameters.type
     * <li>column size: 16
     * <li>jdbc type returned by the driver: Types.VARCHAR
     * </ul>
     *
     * @return the value of type
     */
    public String getType()
    {
        return type; 
    }

    /**
     * Setter method for type.
     * <br>
     * The new value is set only if compareTo() says it is different,
     * or if one of either the new value or the current value is null.
     * In case the new value is different, it is set and the field is marked as 'modified'.
     *
     * @param newVal the new value to be assigned to type
     */
    public void setType(String newVal) {
        if ((newVal != null && this.type != null && (newVal.compareTo(this.type) == 0)) || 
            (newVal == null && this.type == null && type_is_initialized)) {
            return; 
        } 
        this.type = newVal; 
        type_is_modified = true; 
        type_is_initialized = true; 
    }

    /**
     * Determines if the type has been modified.
     *
     * @return true if the field has been modified, false if the field has not been modified
     */
    public boolean isTypeModified() {
        return type_is_modified; 
    }

    /**
     * Determines if the type has been initialized.
     * <br>
     * It is useful to determine if a field is null on purpose or just because it has not been initialized.
     *
     * @return true if the field has been initialized, false otherwise
     */
    public boolean isTypeInitialized() {
        return type_is_initialized; 
    }

    /**
     * Getter method for format.
     * <br>
     * Meta Data Information (in progress):
     * <ul>
     * <li>full name: did_parameters.format
     * <li>column size: 8
     * <li>jdbc type returned by the driver: Types.VARCHAR
     * </ul>
     *
     * @return the value of format
     */
    public String getFormat()
    {
        return format; 
    }

    /**
     * Setter method for format.
     * <br>
     * The new value is set only if compareTo() says it is different,
     * or if one of either the new value or the current value is null.
     * In case the new value is different, it is set and the field is marked as 'modified'.
     *
     * @param newVal the new value to be assigned to format
     */
    public void setFormat(String newVal) {
        if ((newVal != null && this.format != null && (newVal.compareTo(this.format) == 0)) || 
            (newVal == null && this.format == null && format_is_initialized)) {
            return; 
        } 
        this.format = newVal; 
        format_is_modified = true; 
        format_is_initialized = true; 
    }

    /**
     * Determines if the format has been modified.
     *
     * @return true if the field has been modified, false if the field has not been modified
     */
    public boolean isFormatModified() {
        return format_is_modified; 
    }

    /**
     * Determines if the format has been initialized.
     * <br>
     * It is useful to determine if a field is null on purpose or just because it has not been initialized.
     *
     * @return true if the field has been initialized, false otherwise
     */
    public boolean isFormatInitialized() {
        return format_is_initialized; 
    }

    /**
     * Getter method for unit.
     * <br>
     * Meta Data Information (in progress):
     * <ul>
     * <li>full name: did_parameters.unit
     * <li>column size: 16
     * <li>jdbc type returned by the driver: Types.VARCHAR
     * </ul>
     *
     * @return the value of unit
     */
    public String getUnit()
    {
        return unit; 
    }

    /**
     * Setter method for unit.
     * <br>
     * The new value is set only if compareTo() says it is different,
     * or if one of either the new value or the current value is null.
     * In case the new value is different, it is set and the field is marked as 'modified'.
     *
     * @param newVal the new value to be assigned to unit
     */
    public void setUnit(String newVal) {
        if ((newVal != null && this.unit != null && (newVal.compareTo(this.unit) == 0)) || 
            (newVal == null && this.unit == null && unit_is_initialized)) {
            return; 
        } 
        this.unit = newVal; 
        unit_is_modified = true; 
        unit_is_initialized = true; 
    }

    /**
     * Determines if the unit has been modified.
     *
     * @return true if the field has been modified, false if the field has not been modified
     */
    public boolean isUnitModified() {
        return unit_is_modified; 
    }

    /**
     * Determines if the unit has been initialized.
     * <br>
     * It is useful to determine if a field is null on purpose or just because it has not been initialized.
     *
     * @return true if the field has been initialized, false otherwise
     */
    public boolean isUnitInitialized() {
        return unit_is_initialized; 
    }

    /**
     * Getter method for comment.
     * <br>
     * Meta Data Information (in progress):
     * <ul>
     * <li>full name: did_parameters.comment
     * <li>column size: 100
     * <li>jdbc type returned by the driver: Types.VARCHAR
     * </ul>
     *
     * @return the value of comment
     */
    public String getComment()
    {
        return comment; 
    }

    /**
     * Setter method for comment.
     * <br>
     * The new value is set only if compareTo() says it is different,
     * or if one of either the new value or the current value is null.
     * In case the new value is different, it is set and the field is marked as 'modified'.
     *
     * @param newVal the new value to be assigned to comment
     */
    public void setComment(String newVal) {
        if ((newVal != null && this.comment != null && (newVal.compareTo(this.comment) == 0)) || 
            (newVal == null && this.comment == null && comment_is_initialized)) {
            return; 
        } 
        this.comment = newVal; 
        comment_is_modified = true; 
        comment_is_initialized = true; 
    }

    /**
     * Determines if the comment has been modified.
     *
     * @return true if the field has been modified, false if the field has not been modified
     */
    public boolean isCommentModified() {
        return comment_is_modified; 
    }

    /**
     * Determines if the comment has been initialized.
     * <br>
     * It is useful to determine if a field is null on purpose or just because it has not been initialized.
     *
     * @return true if the field has been initialized, false otherwise
     */
    public boolean isCommentInitialized() {
        return comment_is_initialized; 
    }

    /**
     * Getter method for description.
     * <br>
     * Meta Data Information (in progress):
     * <ul>
     * <li>full name: did_parameters.description
     * <li>column size: 2147483647
     * <li>jdbc type returned by the driver: Types.LONGVARCHAR
     * </ul>
     *
     * @return the value of description
     */
    public String getDescription()
    {
        return description; 
    }

    /**
     * Setter method for description.
     * <br>
     * The new value is set only if compareTo() says it is different,
     * or if one of either the new value or the current value is null.
     * In case the new value is different, it is set and the field is marked as 'modified'.
     *
     * @param newVal the new value to be assigned to description
     */
    public void setDescription(String newVal) {
        if ((newVal != null && this.description != null && (newVal.compareTo(this.description) == 0)) || 
            (newVal == null && this.description == null && description_is_initialized)) {
            return; 
        } 
        this.description = newVal; 
        description_is_modified = true; 
        description_is_initialized = true; 
    }

    /**
     * Determines if the description has been modified.
     *
     * @return true if the field has been modified, false if the field has not been modified
     */
    public boolean isDescriptionModified() {
        return description_is_modified; 
    }

    /**
     * Determines if the description has been initialized.
     * <br>
     * It is useful to determine if a field is null on purpose or just because it has not been initialized.
     *
     * @return true if the field has been initialized, false otherwise
     */
    public boolean isDescriptionInitialized() {
        return description_is_initialized; 
    }

    /**
     * Getter method for range.
     * <br>
     * Meta Data Information (in progress):
     * <ul>
     * <li>full name: did_parameters.range
     * <li>column size: 255
     * <li>jdbc type returned by the driver: Types.VARCHAR
     * </ul>
     *
     * @return the value of range
     */
    public String getRange()
    {
        return range; 
    }

    /**
     * Setter method for range.
     * <br>
     * The new value is set only if compareTo() says it is different,
     * or if one of either the new value or the current value is null.
     * In case the new value is different, it is set and the field is marked as 'modified'.
     *
     * @param newVal the new value to be assigned to range
     */
    public void setRange(String newVal) {
        if ((newVal != null && this.range != null && (newVal.compareTo(this.range) == 0)) || 
            (newVal == null && this.range == null && range_is_initialized)) {
            return; 
        } 
        this.range = newVal; 
        range_is_modified = true; 
        range_is_initialized = true; 
    }

    /**
     * Determines if the range has been modified.
     *
     * @return true if the field has been modified, false if the field has not been modified
     */
    public boolean isRangeModified() {
        return range_is_modified; 
    }

    /**
     * Determines if the range has been initialized.
     * <br>
     * It is useful to determine if a field is null on purpose or just because it has not been initialized.
     *
     * @return true if the field has been initialized, false otherwise
     */
    public boolean isRangeInitialized() {
        return range_is_initialized; 
    }

    /**
     * Getter method for defaultValue.
     * <br>
     * Meta Data Information (in progress):
     * <ul>
     * <li>full name: did_parameters.default_value
     * <li>column size: 255
     * <li>jdbc type returned by the driver: Types.VARCHAR
     * </ul>
     *
     * @return the value of defaultValue
     */
    public String getDefaultValue()
    {
        return defaultValue; 
    }

    /**
     * Setter method for defaultValue.
     * <br>
     * The new value is set only if compareTo() says it is different,
     * or if one of either the new value or the current value is null.
     * In case the new value is different, it is set and the field is marked as 'modified'.
     *
     * @param newVal the new value to be assigned to defaultValue
     */
    public void setDefaultValue(String newVal) {
        if ((newVal != null && this.defaultValue != null && (newVal.compareTo(this.defaultValue) == 0)) || 
            (newVal == null && this.defaultValue == null && defaultValue_is_initialized)) {
            return; 
        } 
        this.defaultValue = newVal; 
        defaultValue_is_modified = true; 
        defaultValue_is_initialized = true; 
    }

    /**
     * Determines if the defaultValue has been modified.
     *
     * @return true if the field has been modified, false if the field has not been modified
     */
    public boolean isDefaultValueModified() {
        return defaultValue_is_modified; 
    }

    /**
     * Determines if the defaultValue has been initialized.
     * <br>
     * It is useful to determine if a field is null on purpose or just because it has not been initialized.
     *
     * @return true if the field has been initialized, false otherwise
     */
    public boolean isDefaultValueInitialized() {
        return defaultValue_is_initialized; 
    }

    /**
     * Getter method for mandatory.
     * <br>
     * Meta Data Information (in progress):
     * <ul>
     * <li>full name: did_parameters.mandatory
     * <li>default value: 0
     * <li>column size: 3
     * <li>jdbc type returned by the driver: Types.TINYINT
     * </ul>
     *
     * @return the value of mandatory
     */
    public Integer getMandatory()
    {
        return mandatory; 
    }

    /**
     * Setter method for mandatory.
     * <br>
     * The new value is set only if compareTo() says it is different,
     * or if one of either the new value or the current value is null.
     * In case the new value is different, it is set and the field is marked as 'modified'.
     *
     * @param newVal the new value to be assigned to mandatory
     */
    public void setMandatory(Integer newVal) {
        if ((newVal != null && this.mandatory != null && (newVal.compareTo(this.mandatory) == 0)) || 
            (newVal == null && this.mandatory == null && mandatory_is_initialized)) {
            return; 
        } 
        this.mandatory = newVal; 
        mandatory_is_modified = true; 
        mandatory_is_initialized = true; 
    }

    /**
     * Setter method for mandatory.
     * <br>
     * Convenient for those who do not want to deal with Objects for primary types.
     *
     * @param newVal the new value to be assigned to mandatory
     */
    public void setMandatory(int newVal) {
        setMandatory(new Integer(newVal));
    }

    /**
     * Determines if the mandatory has been modified.
     *
     * @return true if the field has been modified, false if the field has not been modified
     */
    public boolean isMandatoryModified() {
        return mandatory_is_modified; 
    }

    /**
     * Determines if the mandatory has been initialized.
     * <br>
     * It is useful to determine if a field is null on purpose or just because it has not been initialized.
     *
     * @return true if the field has been initialized, false otherwise
     */
    public boolean isMandatoryInitialized() {
        return mandatory_is_initialized; 
    }

    /**
     * Getter method for zprotected.
     * <br>
     * Meta Data Information (in progress):
     * <ul>
     * <li>full name: did_parameters.zprotected
     * <li>default value: 0

     * <li>column size: 3
     * <li>jdbc type returned by the driver: Types.TINYINT
     * </ul>
     *
     * @return the value of zprotected
     */
    public Integer getZprotected()
    {
        return zprotected; 
    }

    /**
     * Setter method for zprotected.
     * <br>
     * The new value is set only if compareTo() says it is different,
     * or if one of either the new value or the current value is null.
     * In case the new value is different, it is set and the field is marked as 'modified'.
     *
     * @param newVal the new value to be assigned to zprotected
     */
    public void setZprotected(Integer newVal) {
        if ((newVal != null && this.zprotected != null && (newVal.compareTo(this.zprotected) == 0)) || 
            (newVal == null && this.zprotected == null && zprotected_is_initialized)) {
            return; 
        } 
        this.zprotected = newVal; 
        zprotected_is_modified = true; 
        zprotected_is_initialized = true; 
    }

    /**
     * Setter method for zprotected.
     * <br>
     * Convenient for those who do not want to deal with Objects for primary types.
     *
     * @param newVal the new value to be assigned to zprotected
     */
    public void setZprotected(int newVal) {
        setZprotected(new Integer(newVal));
    }

    /**
     * Determines if the zprotected has been modified.
     *
     * @return true if the field has been modified, false if the field has not been modified
     */
    public boolean isZprotectedModified() {
        return zprotected_is_modified; 
    }

    /**
     * Determines if the zprotected has been initialized.
     * <br>
     * It is useful to determine if a field is null on purpose or just because it has not been initialized.
     *
     * @return true if the field has been initialized, false otherwise
     */
    public boolean isZprotectedInitialized() {
        return zprotected_is_initialized; 
    }

    /**
     * Determines if the current object is new.
     *
     * @return true if the current object is new, false if the object is not new
     */
    public boolean isNew() {
        return _isNew;
    }

    /**
     * Specifies to the object if it has been set as new.
     *
     * @param isNew the boolean value to be assigned to the isNew field
     */
    public void isNew(boolean isNew) {
        this._isNew = isNew;
    }

    /**
     * Determines if the object has been modified since the last time this method was called.
     * <br>
     * We can also determine if this object has ever been modified since its creation.
     *
     * @return true if the object has been modified, false if the object has not been modified
     */
    public boolean isModified() {
        return code_is_modified || 
		parameter_is_modified || 
		zclass_is_modified || 
		context_is_modified || 
		type_is_modified || 
		format_is_modified || 
		unit_is_modified || 
		comment_is_modified || 
		description_is_modified || 
		range_is_modified || 
		defaultValue_is_modified || 
		mandatory_is_modified || 
		zprotected_is_modified;
    }

    /**
     * Resets the object modification status to 'not modified'.
     */
    public void resetIsModified() {
        code_is_modified = false;
        parameter_is_modified = false;
        zclass_is_modified = false;
        context_is_modified = false;
        type_is_modified = false;
        format_is_modified = false;
        unit_is_modified = false;
        comment_is_modified = false;
        description_is_modified = false;
        range_is_modified = false;
        defaultValue_is_modified = false;
        mandatory_is_modified = false;
        zprotected_is_modified = false;
    }

    /**
     * Copies the passed bean into the current bean.
     *
     * @param bean the bean to copy into the current bean
     */
    public void copy(DidParameter bean) {
        setCode(bean.getCode());
        setParameter(bean.getParameter());
        setZclass(bean.getZclass());
        setContext(bean.getContext());
        setType(bean.getType());
        setFormat(bean.getFormat());
        setUnit(bean.getUnit());
        setComment(bean.getComment());
        setDescription(bean.getDescription());
        setRange(bean.getRange());
        setDefaultValue(bean.getDefaultValue());
        setMandatory(bean.getMandatory());
        setZprotected(bean.getZprotected());
    }

    /**
     * Returns the object string representation.
     *
     * @return the object as a string
     */
    public String toString() {
        return   "\n[did_parameters] "
                 + "\n - did_parameters.code = " + (code_is_initialized ? ("[" + (code == null ? null : code.toString()) + "]") : "not initialized") + ""
                 + "\n - did_parameters.parameter = " + (parameter_is_initialized ? ("[" + (parameter == null ? null : parameter.toString()) + "]") : "not initialized") + ""
                 + "\n - did_parameters.zclass = " + (zclass_is_initialized ? ("[" + (zclass == null ? null : zclass.toString()) + "]") : "not initialized") + ""
                 + "\n - did_parameters.context = " + (context_is_initialized ? ("[" + (context == null ? null : context.toString()) + "]") : "not initialized") + ""
                 + "\n - did_parameters.type = " + (type_is_initialized ? ("[" + (type == null ? null : type.toString()) + "]") : "not initialized") + ""
                 + "\n - did_parameters.format = " + (format_is_initialized ? ("[" + (format == null ? null : format.toString()) + "]") : "not initialized") + ""
                 + "\n - did_parameters.unit = " + (unit_is_initialized ? ("[" + (unit == null ? null : unit.toString()) + "]") : "not initialized") + ""
                 + "\n - did_parameters.comment = " + (comment_is_initialized ? ("[" + (comment == null ? null : comment.toString()) + "]") : "not initialized") + ""
                 + "\n - did_parameters.description = " + (description_is_initialized ? ("[" + (description == null ? null : description.toString()) + "]") : "not initialized") + ""
                 + "\n - did_parameters.range = " + (range_is_initialized ? ("[" + (range == null ? null : range.toString()) + "]") : "not initialized") + ""
                 + "\n - did_parameters.default_value = " + (defaultValue_is_initialized ? ("[" + (defaultValue == null ? null : defaultValue.toString()) + "]") : "not initialized") + ""
                 + "\n - did_parameters.mandatory = " + (mandatory_is_initialized ? ("[" + (mandatory == null ? null : mandatory.toString()) + "]") : "not initialized") + ""
                 + "\n - did_parameters.zprotected = " + (zprotected_is_initialized ? ("[" + (zprotected == null ? null : zprotected.toString()) + "]") : "not initialized") + ""
            ;
    }
 
}
