package org.eso.oca.data;

import java.sql.SQLException;

/**
 * Interface DidParametersListener
 * 
 * Listener that is notified of did_parameters table changes.
 *
 * @version $Revision: 1.3 $
 * @author pnunes, Apr 22, 2005
 */


/**
 * Listener that is notified of did_parameters table changes.
 */
public interface DidParametersListener

{
    /**
     * Invoked just before inserting a DidParametersBean record into the database.
     *
     * @param pObject the DidParametersBean that is about to be inserted
     */
    public void beforeInsert(DidParameter pObject) throws SQLException;


    /**
     * Invoked just after a DidParametersBean record is inserted in the database.
     *
     * @param pObject the DidParametersBean that was just inserted
     */
    public void afterInsert(DidParameter pObject) throws SQLException;


    /**
     * Invoked just before updating a DidParametersBean record in the database.
     *
     * @param pObject the DidParametersBean that is about to be updated
     */
    public void beforeUpdate(DidParameter pObject) throws SQLException;


    /**
     * Invoked just after updating a DidParametersBean record in the database.
     *
     * @param pObject the DidParametersBean that was just updated
     */
    public void afterUpdate(DidParameter pObject) throws SQLException;



}
