package org.eso.oca.data;

import java.sql.SQLException;


/**
 * Interface ObsColumnsListener
 * 
 * Listener that is notified of obs_columns table changes.
 *
 * @version $Revision: 1.4 $
 * @author pnunes, Mar 30, 2005
 */


public interface ObsColumnsListener

{
    /**
     * Invoked just before inserting a ObsColumnsBean record into the database.
     *
     * @param pObject the ObsColumnsBean that is about to be inserted
     */
    public void beforeInsert(MetaColumn pObject) throws SQLException;


    /**
     * Invoked just after a ObsColumnsBean record is inserted in the database.
     *
     * @param pObject the ObsColumnsBean that was just inserted
     */
    public void afterInsert(MetaColumn pObject) throws SQLException;


    /**
     * Invoked just before updating a ObsColumnsBean record in the database.
     *
     * @param pObject the ObsColumnsBean that is about to be updated
     */
    public void beforeUpdate(MetaColumn pObject) throws SQLException;


    /**
     * Invoked just after updating a ObsColumnsBean record in the database.
     *
     * @param pObject the ObsColumnsBean that was just updated
     */
    public void afterUpdate(MetaColumn pObject) throws SQLException;

}
