package org.eso.oca.fits;

import java.math.BigDecimal;
import java.util.Comparator;

import org.eso.oca.fits.OCAFile;

/**
 * This class can be used to sort a collection of OCAFile
 * objects according to the file creation date (MJD-OBS).
 * 
 * @author szampier
 */
public class CompareMjdObs implements Comparator<OCAFile> {

    // Documentation is inherited from the Comparator<> interface. 
	public int compare(OCAFile left, OCAFile right) {
		BigDecimal leftMjdObs;
		BigDecimal rightMjdObs;
		try {
			leftMjdObs = left.getMjdObs();
			rightMjdObs = right.getMjdObs();
		} catch (Exception e) {
			return 0;
		}
		return (leftMjdObs.compareTo(rightMjdObs));
	}
}
