package org.eso.oca.fits;

import java.lang.String;
import java.lang.Exception;

/** This exception is thrown when a keyword is not found
 *
 * @author szampier@eso.org
 */
public class KeywordNotFoundException extends Exception
{
    /** Creates a KeywordNotFoundException with no detail message or cause. */
    public KeywordNotFoundException()
    {
        super();
    }

    /** Creates a KeywordNotFoundException with the specified detail message. 
     * 
     * @param message a detail message for this exception. 
     */
    public KeywordNotFoundException(String message)
    {
        super(message);
    }

    /** Creates a KeywordNotFoundException with the specified detail message 
     * and cause. 
     *
     * @param message a detail message for this exception. 
     * @param cause a Throwable which represents the underlying cause of 
     *              this exception. 
     */
    public KeywordNotFoundException(String message, Throwable cause)
    {
        super(message, cause);
    }

    /** Creates a KeywordNotFoundException with the specified cause. 
     * 
     * @param cause a Throwable which represents the underlying cause of 
     *              this exception. 
     */
    public KeywordNotFoundException(Throwable cause)
    {
        super(cause);
    }
}
