package org.eso.oca.fits;

import java.lang.String;
import java.lang.Exception;

/** This exception is thrown if a FITS value type could not be determined 
 * during the construction of a TypedHeaderCard. 
 *
 * @author Neil Ferguson ESO/DMD/DFS <nferguso@eso.org> 
 */
public class TypeDeterminationException extends Exception
{
    /** Creates a TypeDeterminationException with no detail message or 
     * cause. 
     */ 
    public TypeDeterminationException()
    {
        super();
    }

    /** Creates a TypeDeterminationException with the specified detail 
     * message. 
     * 
     * @param message a detail message for this exception. 
     */
    public TypeDeterminationException(String message)
    {
        super(message);
    }

    /** Creates a TypeDeterminationException with the specified detail 
     * message and cause. 
     *
     * @param message a detail message for this exception. 
     * @param cause a Throwable which represents the underlying cause of 
     *              this exception. 
     */
    public TypeDeterminationException(String message, Throwable cause)
    {
        super(message, cause);
    }

    /** Creates a TypeDeterminationException with the specified cause. 
     * 
     * @param cause a Throwable which represents the underlying cause of 
     *              this exception. 
     */
    public TypeDeterminationException(Throwable cause)
    {
        super(cause);
    }
}
