package org.eso.oca.fits;

import java.lang.String;
import java.lang.Exception;

/** This exception is thrown if an attempt to construct a TypedHeaderCard 
 * fails (usually within the HeaderCard superclass constructor). 
 *
 * @author Neil Ferguson ESO/DMD/DFS <nferguso@eso.org> 
 */
public class TypedHeaderCardException extends Exception
{
    /** Creates a TypedHeaderCardException with no detail message or cause. */
    public TypedHeaderCardException()
    {
        super();
    }

    /** Creates a TypedHeaderCardException with the specified detail message. 
     * 
     * @param message a detail message for this exception. 
     */
    public TypedHeaderCardException(String message)
    {
        super(message);
    }

    /** Creates a TypedHeaderCardException with the specified detail message 
     * and cause. 
     *
     * @param message a detail message for this exception. 
     * @param cause a Throwable which represents the underlying cause of 
     *              this exception. 
     */
    public TypedHeaderCardException(String message, Throwable cause)
    {
        super(message, cause);
    }

    /** Creates a TypedHeaderCardException with the specified cause. 
     * 
     * @param cause a Throwable which represents the underlying cause of 
     *              this exception. 
     */
    public TypedHeaderCardException(Throwable cause)
    {
        super(cause);
    }
}
