package org.eso.oca.fitsmapper;

import java.sql.SQLException;

import org.eso.oca.data.DidParameter;
import org.eso.oca.data.DidParametersDAO;
import org.eso.oca.data.JdbcConnectionException;

/**
 * Class DbKeywordDictionary
 * 
 * This class accesses the "did" database It maps between keywords and keyword
 * types Queries the database for every request
 * 
 * @version $Revision: 1.5 $
 * @author pnunes, Apr 25, 2005
 */

// $Id: DbKeywordDictionary.java,v 1.5 2005/06/06 10:31:18 szampier Exp $
public class DbKeywordDictionary
{

    /**
     * Database connection
     */
    private DidParametersDAO didParametersDAO;

    /**
     * Fits types
     */
    private static final String[] fitsTypes =
    { "double", "integer", "logical", "string" };

    /**
     * Sql types
     */
    private static final String[] sqlTypes =
    { "real", "int", "char(1)", "varchar(50)" };

    /**
     * Constructor
     */
    public DbKeywordDictionary()
    {
    }

    /**
     * @param keyword
     * @return
     * @throws SQLException
     * @throws JdbcConnectionException
     * @throws DbKeywordDictionaryException
     */
    public String getFitsType(String keyword) throws SQLException,
            JdbcConnectionException, DbKeywordDictionaryException
    {
        DidParametersDAO didParametersDAO = DidParametersDAO.getInstance();

        //	replace "." with " "
        String parameter = getDidParameter(keyword);

        DidParameter[] didParameters = didParametersDAO
                .loadByWhere("where parameter like '" + parameter + "'");

        if (didParameters.length == 0)
        {
            throw new DbKeywordDictionaryException(
                    "Can't find parameter "+keyword+" in DidRep");
        }
        else
        {
            DidParameter didParameter = didParameters[0];
            return (didParameter.getType());
        }
    }

    /**
     * @param keyword
     * @return
     * @throws SQLException
     * @throws JdbcConnectionException
     * @throws DbKeywordDictionaryException
     */
    public String getSQLType(String keyword) throws SQLException,
            JdbcConnectionException, DbKeywordDictionaryException
    {
        String fitsType = getFitsType(keyword);
        for (int i = 0; i < fitsTypes.length; i++)
        {
            if (fitsTypes[i].equals(fitsType))
                return sqlTypes[i];
        }
        throw new DbKeywordDictionaryException("Unknown type "+fitsType);
    }

    /**
     * @param keyword
     * @return
     */
    private String getDidParameter(String keyword)
    {
        if (keyword == null)
            throw new IllegalArgumentException("null keyword");
        return keyword.replaceAll("[0-9]","").replace('.','%'); 
    }
}

