/* Generated By:JJTree: Do not edit this line. ASTLogicalOr.java */

package org.eso.oca.parser;

import org.apache.log4j.Logger;

public class ASTLogicalOr extends SimpleNode
{
    public ASTLogicalOr(int id)
    {
        super(id);
    }

    public ASTLogicalOr(OcaParser p, int id)
    {
        super(p, id);
    }

    /** Accept the visitor. * 
     * @throws OcaVisitorException*/
    public Object jjtAccept(OcaParserVisitor visitor, Object data) throws OcaVisitorException
    {
        return visitor.visit(this, data);
    }

    public int precedence()
    {
        return LOGICAL_OR_PRECEDENCE;
    }

    static Logger logger = Logger.getLogger(ASTLogicalOr.class);

    public void interpret(OCAState state) throws InterpretationException 
    {
        logger.debug("interpret() called."); 

        /* Interpret the left hand side of the OR. */
        jjtGetChild(0).interpret(state);

        /* The result needs to be Boolean. */
        state.stack[state.top] = getBoolean(state.stack[state.top]); 

        /* Following the principle of short-circuit operators, the right 
         * hand side of the OR (and the OR operation itself) only need 
         * to be interpreted if the left hand side was false. 
         */
        if(!((Boolean) state.stack[state.top]).booleanValue())
        {
            /* Interpret the right hand side of the OR. */ 
            jjtGetChild(1).interpret(state);

            /* The result needs to be Boolean. */
            state.stack[state.top] = getBoolean(state.stack[state.top]); 

            /* Perform the OR operation. */
            state.stack[--state.top] = 
                new Boolean(((Boolean) state.stack[state.top]).booleanValue()
                            || ((Boolean) state.stack[state.top + 1]).booleanValue()); 
        }
    }
}
