/* Generated By:JJTree: Do not edit this line. ASTMultiplication.java */

package org.eso.oca.parser;

import org.eso.oca.fits.TypedHeaderCard;
import org.eso.oca.fits.UndefinedFITSValue;

import java.lang.String;

import java.math.BigDecimal; 
import java.math.BigInteger; 

import org.apache.log4j.Logger;

public class ASTMultiplication extends SimpleNode
{
    public ASTMultiplication(int id)
    {
        super(id);
    }

    public ASTMultiplication(OcaParser p, int id)
    {
        super(p, id);
    }

    /** Accept the visitor. * 
     * @throws OcaVisitorException*/
    public Object jjtAccept(OcaParserVisitor visitor, Object data) throws OcaVisitorException
    {
        return visitor.visit(this, data);
    }

    public int precedence()
    {
        return MULTIPLICATION_PRECEDENCE;
    }

    static Logger logger = Logger.getLogger(ASTMultiplication.class);

    /** Generic fallback method for the dispatcher which catches attempts 
     * to multiply invalid operands. Logs an error and throws an exception. 
     *
     * @throws InterpretationException in all cases. 
     */
    Object multiply(Object leftOperand, Object rightOperand) 
        throws InterpretationException 
    {
        String message = getNodeLocationString() 
            + "Operator '*' may not be used for \"" 
            + TypedHeaderCard.findFITSTypeString(leftOperand) + " * " 
            + TypedHeaderCard.findFITSTypeString(rightOperand) + "\"."; 

        logger.error(message);
        throw new InterpretationException(message);
    }

    /** "Multiplies" an undefined value by any operand type; always returns 
     * an undefined result. 
     */
    UndefinedFITSValue multiply(UndefinedFITSValue leftOperand, 
                                Object rightOperand) 
    {
        String message = getNodeLocationString() 
            + "Operator '*' used with undefined operand: \"" 
            + TypedHeaderCard.findFITSTypeString(leftOperand) + " * " 
            + TypedHeaderCard.findFITSTypeString(rightOperand) + "\".";

        logger.warn(message);
        return(new UndefinedFITSValue()); 
    }

    /** "Multiplies" any operand type by an undefined value; always returns 
     * an undefined result. 
     */
    UndefinedFITSValue multiply(Object leftOperand, 
                                UndefinedFITSValue rightOperand) 
    {
        String message = getNodeLocationString() 
            + "Operator '*' used with undefined operand: \"" 
            + TypedHeaderCard.findFITSTypeString(leftOperand) + " * " 
            + TypedHeaderCard.findFITSTypeString(rightOperand) + "\".";

        logger.warn(message);
        return(new UndefinedFITSValue()); 
    }

    /** Multiplies two BigDecimals and returns the result. */ 
    BigDecimal multiply(BigDecimal leftOperand, BigDecimal rightOperand)
    {
        return(leftOperand.multiply(rightOperand)); 
    }

    /** Multiplies a BigDecimal by a BigInteger and returns the result. 
     * The BigInteger is promoted to a BigDecimal first, and a warning 
     * is logged about the type mismatch. 
     */ 
    BigDecimal multiply(BigDecimal leftOperand, BigInteger rightOperand)
    {
        logger.warn(getNodeLocationString() + "Performing '" 
                    + TypedHeaderCard.findFITSTypeString(leftOperand) + " * "
                    + TypedHeaderCard.findFITSTypeString(rightOperand) + "'.");
        return(leftOperand.multiply(new BigDecimal(rightOperand))); 
    }

    /** Multiplies a BigInteger by a BigDecimal and returns the result. 
     * The BigInteger is promoted to a BigDecimal first, and a warning 
     * is logged about the type mismatch. 
     */ 
    BigDecimal multiply(BigInteger leftOperand, BigDecimal rightOperand)
    {
        logger.warn(getNodeLocationString() + "Performing '" 
                    + TypedHeaderCard.findFITSTypeString(leftOperand) + " * "
                    + TypedHeaderCard.findFITSTypeString(rightOperand) + "'.");
        return((new BigDecimal(leftOperand)).multiply(rightOperand)); 
    }

    /** Multiplies two BigIntegers and returns the result. */ 
    BigInteger multiply(BigInteger leftOperand, BigInteger rightOperand)
    {
        return(leftOperand.multiply(rightOperand)); 
    }

    public void interpret(OCAState state) throws InterpretationException 
    {
        logger.debug("interpret() called."); 

        jjtGetChild(0).interpret(state);
        jjtGetChild(1).interpret(state);

        /* Perform the operation by dispatching to the multiply(l,r) methods 
         * defined above. Dispatching is based on the operand types. 
         */ 
        state.stack[--state.top] = 
            dispatch(this.getClass(), 
                     "multiply", 
                     new Object[] {state.stack[state.top], 
                                   state.stack[state.top + 1]}); 
    }
}
