/* Generated By:JJTree: Do not edit this line. ASTRemainder.java */

package org.eso.oca.parser;

import org.eso.oca.fits.TypedHeaderCard;
import org.eso.oca.fits.UndefinedFITSValue;

import java.lang.String;

import java.math.BigInteger; 

import org.apache.log4j.Logger;

public class ASTRemainder extends SimpleNode
{
    public ASTRemainder(int id)
    {
        super(id);
    }

    public ASTRemainder(OcaParser p, int id)
    {
        super(p, id);
    }

    /** Accept the visitor. * 
     * @throws OcaVisitorException*/
    public Object jjtAccept(OcaParserVisitor visitor, Object data) throws OcaVisitorException
    {
        return visitor.visit(this, data);
    }

    public int precedence()
    {
        return MULTIPLICATION_PRECEDENCE;
    }

    static Logger logger = Logger.getLogger(ASTRemainder.class);

    /** Generic fallback method for the dispatcher which catches attempts 
     * to get a remainder from dividing invalid operands. Logs an error 
     * and throws an exception. 
     *
     * @throws InterpretationException in all cases. 
     */
    Object remainder(Object leftOperand, Object rightOperand) 
        throws InterpretationException 
    {
        String message = getNodeLocationString() 
            + "Operator '%' may not be used for \"" 
            + TypedHeaderCard.findFITSTypeString(leftOperand) + " % " 
            + TypedHeaderCard.findFITSTypeString(rightOperand) + "\"."; 

        logger.error(message);
        throw new InterpretationException(message);
    }

    /** "Returns the remainder" from dividing an undefined value by any 
     * operand type; always returns an undefined result. 
     */
    UndefinedFITSValue remainder(UndefinedFITSValue leftOperand, 
                                 Object rightOperand) 
    {
        String message = getNodeLocationString() 
            + "Operator '%' used with undefined operand: \"" 
            + TypedHeaderCard.findFITSTypeString(leftOperand) + " % " 
            + TypedHeaderCard.findFITSTypeString(rightOperand) + "\".";

        logger.warn(message);
        return(new UndefinedFITSValue()); 
    }

    /** "Returns the remainder" from dividing any operand type by an 
     * undefined value; always returns an undefined result. 
     */
    UndefinedFITSValue remainder(Object leftOperand, 
                                 UndefinedFITSValue rightOperand) 
    {
        String message = getNodeLocationString() 
            + "Operator '%' used with undefined operand: \"" 
            + TypedHeaderCard.findFITSTypeString(leftOperand) + " % " 
            + TypedHeaderCard.findFITSTypeString(rightOperand) + "\".";

        logger.warn(message);
        return(new UndefinedFITSValue()); 
    }

    /** Returns the remainder from dividing one BigInteger by another. */ 
    BigInteger remainder(BigInteger leftOperand, BigInteger rightOperand) 
    {
        return(leftOperand.remainder(rightOperand)); 
    }

    public void interpret(OCAState state) throws InterpretationException 
    {
        logger.debug("interpret() called."); 

        jjtGetChild(0).interpret(state);
        jjtGetChild(1).interpret(state);

        /* Perform the operation by dispatching to the remainder(l,r) methods 
         * defined above. Dispatching is based on the operand types. 
         */ 
        state.stack[--state.top] = 
            dispatch(this.getClass(), 
                     "remainder", 
                     new Object[] {state.stack[state.top], 
                                   state.stack[state.top + 1]}); 
    }
}
