/* Generated By:JJTree: Do not edit this line. ASTSubtraction.java */

package org.eso.oca.parser;

import org.eso.oca.fits.TypedHeaderCard;
import org.eso.oca.fits.UndefinedFITSValue;

import java.lang.String;

import java.math.BigDecimal; 
import java.math.BigInteger; 

import org.apache.log4j.Logger;

public class ASTSubtraction extends SimpleNode
{
    public ASTSubtraction(int id)
    {
        super(id);
    }

    public ASTSubtraction(OcaParser p, int id)
    {
        super(p, id);
    }

    /** Accept the visitor. * 
     * @throws OcaVisitorException*/
    public Object jjtAccept(OcaParserVisitor visitor, Object data) throws OcaVisitorException
    {
        return visitor.visit(this, data);
    }

    public int precedence()
    {
        return ADDITION_PRECEDENCE;
    }

    static Logger logger = Logger.getLogger(ASTSubtraction.class);

    /** Generic fallback method for the dispatcher which catches attempts 
     * to subtract invalid operands. Logs an error and throws an exception. 
     *
     * @throws InterpretationException in all cases. 
     */
    Object subtract(Object leftOperand, Object rightOperand) 
        throws InterpretationException 
    {
        String message = getNodeLocationString() 
            + "Operator '-' may not be used for \"" 
            + TypedHeaderCard.findFITSTypeString(leftOperand) + " - " 
            + TypedHeaderCard.findFITSTypeString(rightOperand) + "\"."; 

        logger.error(message);
        throw new InterpretationException(message);
    }

    /** "Subtracts" any operand type from an undefined value; always returns 
     * an undefined result. 
     */
    UndefinedFITSValue subtract(UndefinedFITSValue leftOperand, 
                                Object rightOperand) 
    {
        String message = getNodeLocationString() 
            + "Operator '-' used with undefined operand: \"" 
            + TypedHeaderCard.findFITSTypeString(leftOperand) + " - " 
            + TypedHeaderCard.findFITSTypeString(rightOperand) + "\".";

        logger.warn(message);
        return(new UndefinedFITSValue()); 
    }

    /** "Subtracts" an undefined value from any operand type; always returns 
     * an undefined result. 
     */
    UndefinedFITSValue subtract(Object leftOperand, 
                                UndefinedFITSValue rightOperand) 
    {
        String message = getNodeLocationString() 
            + "Operator '-' used with undefined operand: \"" 
            + TypedHeaderCard.findFITSTypeString(leftOperand) + " - " 
            + TypedHeaderCard.findFITSTypeString(rightOperand) + "\".";

        logger.warn(message);
        return(new UndefinedFITSValue()); 
    }

    /** Subtracts one BigDecimal from another and returns the result. */ 
    BigDecimal subtract(BigDecimal leftOperand, BigDecimal rightOperand)
    {
        return(leftOperand.subtract(rightOperand)); 
    }

    /** Subtracts a BigInteger from a BigDecimal and returns the result. 
     * The BigInteger is promoted to a BigDecimal first, and a warning is 
     * logged about the type mismatch. 
     */ 
    BigDecimal subtract(BigDecimal leftOperand, BigInteger rightOperand)
    {
        logger.warn(getNodeLocationString() + "Performing '" 
                    + TypedHeaderCard.findFITSTypeString(leftOperand) + " - "
                    + TypedHeaderCard.findFITSTypeString(rightOperand) + "'.");
        return(leftOperand.subtract(new BigDecimal(rightOperand))); 
    }

    /** Subtracts a BigDecimal from a BigInteger and returns the result. 
     * The BigInteger is promoted to a BigDecimal first, and a warning is 
     * logged about the type mismatch. 
     */ 
    BigDecimal subtract(BigInteger leftOperand, BigDecimal rightOperand)
    {
        logger.warn(getNodeLocationString() + "Performing '" 
                    + TypedHeaderCard.findFITSTypeString(leftOperand) + " - "
                    + TypedHeaderCard.findFITSTypeString(rightOperand) + "'.");
        return((new BigDecimal(leftOperand)).subtract(rightOperand)); 
    }

    /** Subtracts one BigInteger from another and returns the result. */ 
    BigInteger subtract(BigInteger leftOperand, BigInteger rightOperand)
    {
        return(leftOperand.subtract(rightOperand)); 
    }

    public void interpret(OCAState state) throws InterpretationException 
    {
        logger.debug("interpret() called."); 

        jjtGetChild(0).interpret(state);
        jjtGetChild(1).interpret(state);

        /* Perform the operation by dispatching to the subtract(l,r) methods 
         * defined above. Dispatching is based on the operand types. 
         */ 
        state.stack[--state.top] = 
            dispatch(this.getClass(), 
                     "subtract", 
                     new Object[] {state.stack[state.top], 
                                   state.stack[state.top + 1]}); 
    }
}
