package org.eso.oca.parser;

import java.lang.String;
import java.lang.Exception;

/** This exception is thrown if an error occurs while the OCA system 
 * is interpreting rules with its built-in interpreter. 
 *
 * @author Neil Ferguson ESO/DMD/DFS <nferguso@eso.org> 
 */
public class InterpretationException extends Exception
{
    /** Creates an InterpretationException with no detail message or cause. */ 
    public InterpretationException()
    {
        super();
    }

    /** Creates an InterpretationException with the specified detail message. 
     * 
     * @param message a detail message for this exception. 
     */
    public InterpretationException(String message)
    {
        super(message);
    }

    /** Creates an InterpretationException with the specified detail message 
     * and cause. 
     *
     * @param message a detail message for this exception. 
     * @param cause a Throwable which represents the underlying cause of 
     *              this exception. 
     */
    public InterpretationException(String message, Throwable cause)
    {
        super(message, cause);
    }

    /** Creates an InterpretationException with the specified cause. 
     * 
     * @param cause a Throwable which represents the underlying cause of 
     *              this exception. 
     */
    public InterpretationException(Throwable cause)
    {
        super(cause);
    }
}
