package org.eso.oca.parser;

/**
 * This class is used to store the SQL representation of
 * an OCA "select associate" statement.
 * 
 * The main usage of this class is in connection with the
 * SqlVisitor, where the SQL is incrementally built
 * by the various visit() methods.
 * 
 * @author szampier
 */
public class SelectAssociateState {

	/** The type of association. */
	String alias;
	
	/** The data source: rawFiles or calibFiles. */
	String dataSource;
	
	/** The from clause. */
	StringBuffer fromClause = new StringBuffer();
	
	/** The where clause. */
	StringBuffer whereClause = new StringBuffer();
	
	/** The minimum number of results that must be returned by this query. */
	Integer minRet = new Integer("1");
	
	/** The maximum number of results that can be returned by this query. */
	Integer maxRet = new Integer("1");
	
	/**
	 * Returns string representation of this object.
	 */
	public String toString() {
		StringBuffer buf = new StringBuffer();
		buf.append("minRet = " + minRet + "\n");
		buf.append("maxRet = " + maxRet + "\n");
		buf.append("select frame as " + alias);
		buf.append(" from " + dataSource);
		buf.append(" where " + whereClause);
		return buf.toString();
	}

	public String getAlias() {
		return alias;
	}

	public void setAlias(String alias) {
		this.alias = alias;
	}

	public String getDataSource() {
		return dataSource;
	}

	public void setDataSource(String dataSource) {
		this.dataSource = dataSource;
	}

	public StringBuffer getFromClause() {
		return fromClause;
	}

	public void setFromClause(StringBuffer fromClause) {
		this.fromClause = fromClause;
	}

	public Integer getMaxRet() {
		return maxRet;
	}

	public void setMaxRet(Integer maxRet) {
		this.maxRet = maxRet;
	}

	public Integer getMinRet() {
		return minRet;
	}

	public void setMinRet(Integer minRet) {
		this.minRet = minRet;
	}

	public StringBuffer getWhereClause() {
		return whereClause;
	}

	public void setWhereClause(StringBuffer whereClause) {
		this.whereClause = whereClause;
	}
}
