package org.eso.oca.parser;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.util.LinkedList;

import junit.framework.Test; 
import junit.framework.TestCase; 
import junit.framework.TestSuite; 

/** The current version of this class serves as a placeholder for a more 
 * comprehensive suite of tests that will be implemented later. 
 */ 
public class TestDispatchHelper extends TestCase 
{
    /** Runs all tests in this class directly, using JUnit's text mode. */ 
    public static void main(String args[]) { 
        junit.textui.TestRunner.run(suite());
    }

    /** Returns the suite of all tests in this class. A test is considered 
     * to be any method whose name begins with "test". 
     */
    public static Test suite() { 
        return new TestSuite(TestDispatchHelper.class); 
    }

    /** This class is a fixture of the test. */ 
    public class TestClass
    {
        public void publicOperation()
        {
            // Do nothing. 
        }
    }

    /** Test the DispatchHelper.getMethodSet() method. */
    public void testGetMethodSet()
    {
        /* Get the list of methods available to TestClass which have the 
         * name "publicOperation". 
         */
        LinkedList results = 
            DispatchHelper.getMethodSet(TestClass.class, "publicOperation"); 

        /* The list should contain one element. */
        assertTrue(results.size() == 1);

        Method method = (Method) results.getFirst(); 

        /* The method name should be "publicOperation", it should be public, 
         * take no parameters and return void. 
         */ 
        assertTrue(method.getName().equals("publicOperation")); 
        assertTrue(Modifier.isPublic(method.getModifiers()));
        assertTrue(method.getParameterTypes().length == 0); 
        assertTrue(method.getReturnType() == void.class);
    }
}

