package org.eso.util.dal;

import java.util.List;
import java.sql.Timestamp;

public interface PackageFilesDAO {

	public void insert(List<PackageFile> files) throws DAOException;
	
	public void insertIfNotFound(List<PackageFile> files) throws DAOException;
	
	public void delete(List<PackageFile> files) throws DAOException;
	
	public List<PackageFile> find(Integer pkg_id, Timestamp start, Timestamp stop) throws DAOException;	
	
	public List<PackageFile> find(List<PackageFile> files) throws DAOException;
	
	public boolean findByQCFilename(Integer pkgId, String filePath, String qcFilename) throws DAOException;
	
}
