package org.eso.util.dal;

/**
 * This class maps the table package_info, which defines PI packs 
 *
 * @author vforchi
 *
 */

public class PackageInfo {
	public enum Status {
		OPEN,
		CLOSE
	}
	
	/**
	 * The package ID, defined as runid_instrument
	 */
	private Integer d_packageId = null;

	/**
	 * The run_id to which this package belongs
	 */
	private String d_runId = null;
	
	/**
	 * The instrument used in this package
	 */
	private String d_instrument = null;
	
	/**
	 * An XML file representing association data
	 */
	private String d_assocData = null;
	
	/**
	 * The package status 
	 */
	private Status d_status = null;
	
	public Integer getPackageId() {
		return d_packageId;
	}

	public void setPackageId(Integer id) {
		d_packageId = id;
	}

	public String getRunId() {
		return d_runId;
	}

	public void setRunId(String id) {
		d_runId = id;
	}

	public String getInstrument() {
		return d_instrument;
	}

	public void setInstrument(String d_instrument) {
		this.d_instrument = d_instrument;
	}

	public String getAssocData() {
		return d_assocData;
	}

	public void setAssocData(String data) {
		d_assocData = data;
	}

	public Status getStatus() {
		return d_status;
	}

	public void setStatus(Status d_status) {
		this.d_status = d_status;
	}
}
