package org.eso.util.dal;

import java.util.Comparator;

import org.apache.log4j.Logger;
import org.eso.util.dal.TransferRequest;

/**
 * Implements the Comparator interface to compare transfer requests according to
 * their priority.
 * 
 * @author szampier
 * 
 */
public class TransferRequestPriorityComparator implements Comparator<TransferRequest> {

	/** The name of this class for logging purposes. */
	static final String classLogName = "TransferRequestPriorityComparator";

	/** Apache Log4J logger. */
	static final Logger logger = Logger
			.getLogger(TransferRequestPriorityComparator.class);

	public int compare(TransferRequest leftObj, TransferRequest rightObj) {
		final String methodLogName = classLogName + "::compare()";
		logger.trace(methodLogName);
		return (leftObj.getTransferPriority().compareTo(rightObj.getTransferPriority()));
	}
}
