package org.eso.util.requesthandler;

import java.util.HashMap;
import java.util.Map;

/**
 * Available domain of a ngas host : HEADQUARTER, LASILLA, PARANAL
 * 
 * @author cmoins
 * 
 */
public enum NgasHostDomain {
    HEADQUARTER("hq.eso.org"), LASILLA("ls.eso.org"), PARANAL("pl.eso.org");

    // String reprensation of a ngas host domain status
    private String domain;

    private static final Map<String, NgasHostDomain> INSTANCES =
            new HashMap<String, NgasHostDomain>();

    static {
        NgasHostDomain[] fileDomainArray = NgasHostDomain.values();
        for (int i = 0; i < fileDomainArray.length; i++) {
            INSTANCES.put(fileDomainArray[i].toString(), fileDomainArray[i]);
        }
    }
    NgasHostDomain(String domain) {
        this.domain = domain;
    }

    /** returns the string representation of a ngas host domain enum type element */
    public String toString() {
        return domain;
    }
    /** returns the ngas host domain enum type element associated to a string */
    public static NgasHostDomain getInstance(String domain) {
        return INSTANCES.get(domain.trim());
    }
}
