package org.eso.util.dal.test;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.fail;

import java.sql.Connection;
import java.sql.Statement;
import java.util.TimeZone;

import org.eso.util.dal.DataProductsDAOSyb;
import org.eso.util.dal.SybaseConnectionService;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

public class DataProductDAOSybTest {

	private static DataProductsDAOSyb dao = null;
	private static Statement stmt = null;

	private static final String DBTABLE = "sara..data_products";
	
	private static final String cdb = "test_cdb_file";
	private static final String dp_id = "test_dp_id";
	
	private static Connection conn2;

	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		TimeZone.setDefault(TimeZone.getTimeZone("UTC"));
		dao = new DataProductsDAOSyb("acdbdev:6789", "sara", "sara_ps", DBTABLE);
		conn2 = SybaseConnectionService.getConnection("acdbdev:6789", "sara", "sara_ps");
		stmt = conn2.createStatement();
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
		conn2.close();
	}

	@Before
	public void setUp() throws Exception {		
	}

	@Test
	public void testGetDpId() {
		try {
			truncateTable();
			insertTestEntry(cdb, dp_id);

			/***************************************************************/
			assertEquals(dp_id, dao.getDpId(cdb));
			/****************************************************************/
		} catch (Exception e) {
			fail(e.getMessage());
		}
	}
	
	@Test
	public void testGetCdbFile() {
		try {
			truncateTable();
			insertTestEntry(cdb, dp_id);

			/***************************************************************/
			assertEquals(cdb, dao.getCdbFile(dp_id));
			/****************************************************************/
		} catch (Exception e) {
			fail(e.getMessage());
		}
	}

	public void truncateTable() throws Exception {
		stmt.execute("DELETE FROM " + DBTABLE + " WHERE " + DataProductsDAOSyb.DPID_KW + "='" + dp_id + "'");
	}

	public void insertTestEntry(String cdb, String dp_id) throws Exception {
		String query = "INSERT INTO " + DBTABLE + " (" + DataProductsDAOSyb.CDBFILE_KW + "," + DataProductsDAOSyb.DPID_KW + ") ";
		query += "VALUES ('" + cdb + "','"  + dp_id + "')";
		stmt.execute(query);
	}
}

