package org.eso.dfs.services.gui;

import org.eso.dfs.services.ServiceException;

/**
 * @author Nick Kornweibel
 *
 * This class is the Handler participant in the FileImageDisplay service.
 * The FileImageDisplay service follows the chain of responsibility pattern.
 */

public interface FileImageDisplayHandler {
    
    /**
     * Display the requested file.
     * @param fileIds[] array of files to display (id or full path names).
     * @param showImage if true, this is a request to show the file image.
     * @return boolean true if displayed, else false (not handled
     * and successor will be called)
     * @throws ServiceException if the handler could handle the request
     * but failed (in this case the successor is not requested, as if true
     * was returned from the method).
     */
    public boolean displayFileImages(String[] fileIds, boolean showImage) throws ServiceException;
}
