package org.eso.gasgano.gui;

import java.util.List;

import org.eso.gasgano.keyword.Keyword;

/**
 * @author Nick Kornweibel
 *
 * A table model for viewing and editing an underlying List of Leywords - the table
 * model, being a list, has only a single column.
 */
public class KeywordListAdaptor extends ListAdaptor {

    /**
     * Constructor
     * @param d the data to view and edit.
     * @param t the title of the column as appears in the table
     * @param minOneRow if the list is empty, add one row (nicer for
     * the user to edit).
     */
    public KeywordListAdaptor(List d, String t, boolean minOneRow) {
        super(d, t, "");
    }
    
    /**
     * @see org.eso.gasgano.gui.ListAdaptor#validCellValue(java.lang.Object, int, int)
     */
    public boolean validCellValue(Object aValue, int row, int column) {
        return Keyword.validName((String) aValue);
    }
}
