/**
 * @author N. Kornweibel
 * @version 1.0
 *
 * A Runnable which accepts a Report object, and generates a report.
 * 
 */

package org.eso.gasgano.gui;

import org.eso.gasgano.tools.Report;

public class ReportRunner implements Runnable {

    Report rep = null;
    boolean reportOk = false;
 
    public ReportRunner(Report r) {
        rep = r;
    }

    public boolean reportStatus() {
        return reportOk;
    }

    public void run() {
        if (rep != null) {
            reportOk = rep.generateReport();
        }
    }

    public void interruptReport() {
        if (rep != null) {
            rep.interrupt();
        }
    }

}  // end of interface ReportRunner.
// end of file ReportRunner.java.
