package org.eso.cpl.test;

import java.io.File;

import org.eso.cpl.FrameList;
import org.eso.cpl.Parameter;
import org.eso.cpl.Recipe;
import org.eso.cpl.RecipeLibrary;

/**
 * Dummy recipe library.
 *
 * @author   Mark Taylor
 */
class TestLibrary implements RecipeLibrary {

    private Recipe[] recipes_;
    private Object[] others_;

    public TestLibrary() {
        Recipe rec1 = new TestRecipe("dummy1") {
            {synopsis_ = "Recipe with a description";}
            {setDescriptionLines(new String[] {
                "This recipe",
                "doesn't do anything",
                "but demonstrates that you can make a recipe which is not",
                "based on a CPL library.", "",
                "It subclasses org.eso.cpl.TestLibrary$TestRecipe", "",
                "That is the end",
                "of the description", "",
                "Mark Taylor",
            });}
        };
        Recipe rec2 = new TestRecipe("dummy2");
        Recipe rec3 = new TestRecipe("dummy3");
        Object o1 = "not-a-recipe";
        recipes_ = new Recipe[] {rec1, rec2, rec3,};
        others_ = new Object[] {o1,};
    }

    public String getName() {
        return "Test Library (java class)";
    }

    public String getLocation() {
        return null;
    }

    public Recipe[] getRecipes() {
        return recipes_;
    }

    public Object[] getOtherItems() {
        return others_;
    }

    class TestRecipe implements Recipe {
        String author_ = "Mark Taylor";
        String copyright_ = "ESO";
        String description_ = "unknown";
        String email_ = "m.b.taylor@bristol.ac.uk";
        RecipeLibrary library_ = TestLibrary.this;
        String name_ = null;
        String synopsis_;
        long version_ = 1L;

        public String getAuthor() { return author_; }
        public String getCopyright() { return copyright_; }
        public String getDescription() { return description_; }
        public String getEmail() { return email_; }
        public RecipeLibrary getLibrary() { return library_; }
        public String getName() { return name_; }
        public Parameter[] getDefaultParameters() { return new Parameter[0]; }
        public String getSynopsis() { return synopsis_; }
        public long getVersion() { return version_; }

        TestRecipe(String name) {
            name_ = name;
        }

        public FrameList execute(Parameter[] params, FrameList frames, 
                                 File productRoot) {
            System.out.println("no action");
            return new FrameList();
        }

        void setDescriptionLines(String[] lines) {
            StringBuffer desc = new StringBuffer();
            for (int i = 0; i < lines.length; i++) {
                desc.append(lines[i]).append('\n');
            }
            description_ = desc.toString();
        }
    }
}
